unit CadPerfil_U;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, Buttons, ExtCtrls, StdCtrls,
  Grids, DBGrids, UCDefine;

type
  TCadPerfil = class(TForm)
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    lbDescricao: TLabel;
    Image1: TImage;
    Panel3: TPanel;
    btAdic: TSpeedButton;
    BtAlt: TSpeedButton;
    BtExclui: TSpeedButton;
    BtExit: TSpeedButton;
    DataSource1: TDataSource;
    BtAcess: TSpeedButton;
    procedure BtExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure btAdicClick(Sender: TObject);
    procedure BtAltClick(Sender: TObject);
    procedure BtExcluiClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public
    DsPerfilUser, DSCmd : TDataset;
    FParam : TParams;
    procedure SetWindow(Adicionar: Boolean);
  end;

var
  CadPerfil: TCadPerfil;

implementation

uses IncPerfil_U;



{$R *.dfm}

procedure TCadPerfil.BtExitClick(Sender: TObject);
begin
  Close;
end;

procedure TCadPerfil.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TCadPerfil.DBGrid1DblClick(Sender: TObject);
begin
  BtAlt.Click;
end;

procedure TCadPerfil.btAdicClick(Sender: TObject);
begin
  IncPerfil := TIncPerfil.Create(Self);
  SetWindow(True);
  IncPerfil.ShowModal;
  FreeAndNil(IncPerfil);
end;

procedure TCadPerfil.SetWindow(Adicionar : Boolean);
begin
  with TUCDefine(owner).Settings.AddChangeProfile do begin
    IncPerfil.Caption := WindowCaption;
    if Adicionar then IncPerfil.LbDescricao.Caption := LabelAdd else IncPerfil.LbDescricao.Caption := LabelChange;
    IncPerfil.lbNome.Caption := LabelName;
    IncPerfil.btGravar.Caption := BtSave;
    IncPerfil.btCancela.Caption := BtCancel;
  end;
end;

procedure TCadPerfil.BtAltClick(Sender: TObject);
begin
  if DSPerfilUser.RecordCount = 0 then Exit;
  IncPerfil := TIncPerfil.Create(self);
  SetWindow(False);
  With IncPerfil do begin
    FAltera := True;
    EditDescricao.Text := DSPerfilUser.FieldByName('Nome').asString;
    ShowModal;
  end;
  FreeAndNil(IncPerfil);
end;

procedure TCadPerfil.BtExcluiClick(Sender: TObject);
var
  TempID : Integer;
  CanDelete : Boolean;
  ErrorMsg : String;
begin
  if DSPerfilUser.RecordCount = 0 then Exit;
  TempID := DSPerfilUser.fieldByName('IDUser').asInteger;

  DSCMD.Close;

  IProviderSupport(DSCMD).PSSetCommandText('Select IdUser from '+ TUCDefine(Owner).TableUsers +
                        ' Where tipo = ' + QuotedStr('U') + ' AND Perfil = ' + IntToStr(TempID));
  DSCMD.Open;
  if DSCMD.FieldByName('IdUser').asInteger > 0 then begin
    DSCMD.Close;
    if MessageDlg(Format(TUCDefine(Owner).Settings.UsersProfile.PromptDelete, [DSPerfilUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0)<> mrYes then exit;
  end;

  CanDelete := True;
  if Assigned(TUCDefine(Owner).onDeleteProfile) then TUCDefine(Owner).onDeleteProfile(TObject(Owner), TempID, CanDelete, ErrorMsg);
  if Not CanDelete then begin
    MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
    Exit;
  end;
  DSCMD.Close;
  IProviderSupport(DSCMD).PSExecuteStatement('Delete from '+ TUCDefine(Owner).TableUsers + ' where IDUser = '+ IntToStr(TempID),FParam);
  IProviderSupport(DSCMD).PSExecuteStatement('Delete from '+ TUCDefine(Owner).TableRights + ' where IDUser = '+ IntToStr(TempID),FParam);
  IProviderSupport(DSCMD).PSExecuteStatement('Update '+ TUCDefine(Owner).TableUsers +
                            ' Set Perfil = null where IDUser = '+ IntToStr(TempID),FParam);
  DSPerfilUser.Close;
  DSPerfilUser.Open;

end;

procedure TCadPerfil.FormShow(Sender: TObject);
begin
  FParam := TParams.Create;
  DataSource1.Dataset := DSPerfilUser;
end;

end.
