unit IBOUserControl;

interface

uses
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, IBODataset,
  IB_Components, DB, Dialogs, Menus, ActnList;

type
  TIBOUserControl = class(TUCDefine)
  private
    FConnection : TIBODatabase;
    procedure SetIBOConnection(Value : TIBODatabase);

  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
  public
    property CurrentUser;
  published
    property Connection : TIBODatabase read FConnection write SetIBOConnection;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U;

{ TIBOUserControl }


procedure TIBOUserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TIBOQuery.Create(self);
  TIBOQuery(UserPermis.DSCmd).IB_Connection := FConnection;

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TIBOUserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TIBOQuery.Create(self);
  TIBOQuery(UserPermis.DSCmd).IB_Connection := FConnection;

  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TIBOUserControl.CriaCadUserForm;
begin
  inherited;
  TCadUser(FormCadastroUsuarios).DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
  TCadUser(FormCadastroUsuarios).DSCadUser.Open;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

  TCadUser(FormCadastroUsuarios).DScmd := TIBOQuery.Create(self);
  TIBOQuery(TCadUser(FormCadastroUsuarios).DSCMD).IB_Connection := FConnection;

  TCadUser(FormCadastroUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
  TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
end;

procedure TIBOUserControl.CriaProfileUserForm;
begin
  inherited;
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
  TCadPerfil(FormPerfilUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

  TCadPerfil(FormPerfilUsuarios).DSCmd := TIBOQuery.Create(self);
  TIBOQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).IB_Connection := FConnection;

end;

procedure TIBOUserControl.SetIBOConnection(Value: TIBODatabase);
begin
  if FConnection <> Value then FConnection := Value;
  if FConnection <> nil then FConnection.FreeNotification(Self);
end;

procedure Register;
begin
  RegisterComponents('User Control', [TIBOUserControl]);
end;


procedure TIBOUserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FConnection) then
  begin
    FConnection := nil;
  end;
  inherited Notification(AComponent, Operation);
end;

procedure TIBOUserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).DSLog := TIBOQuery.Create(nil);
  TIBOQuery(tViewLog(FormLogControl).DSLog).IB_Connection := FConnection;
  TViewLog(FormLogControl).DSCmd :=TIBOQuery.Create(nil);
  TIBOQuery(tViewLog(FormLogControl).DSCmd).IB_Connection := FConnection;
  FormLogControl.ShowModal;
  FreeandNil(FormLogControl);
end;


procedure TIBOUserControl.UCExecSQL(FSQL: String);
begin
  FConnection.IB_Transaction.ExecuteImmediate(FSQL);
//  FConnection.Execute(FSQL);

{
  with TIBOQuery.Create(nil) do
  begin
    IB_Connection := FConnection;
    SQL.Text := FSQL;
    ExecSQL;
    Free;
  end;
}
end;


function TIBOUserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  Result := TIBOQuery.Create(nil);
  with Result as TIBOQuery do
  begin
    IB_Connection := FConnection;
    SQL.text := FSQL;
    Open;
  end;
end;

function TIBOUserControl.UCFindTable(const TableName: String): Boolean;
begin
  with TIBOQuery.Create(nil) do begin
    IB_Connection := FConnection;
    SQL.Text := 'SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE RDB$SYSTEM_FLAG = 0 and RDB$RELATION_NAME = '+QuotedStr(Uppercase(TableName));
    Open;
    Result := FieldByName('RDB$RELATION_NAME').asString = Uppercase(TableName);
    Close;
    Free;
  end;
end;


function TIBOUserControl.UCFindDataConnection: Boolean;
begin
    Result := Assigned(FConnection);
end;

end.
