unit IBXUserControl;

interface

uses
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, DB,
  Dialogs, Menus, ActnList, IBCustomDataSet, IBQuery,
  IBDatabase, IBTable;

type
  TIBXUserControl = class(TUCDefine)
  private
    FConnection : TIBDatabase;
    FTransaction : TIBTransaction;
    procedure SetIBXConnection(Value : TIBDatabase);
    procedure SetFTransaction(const Value: TIBTransaction);

  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
  public
    property CurrentUser;
  published
    property Connection : TIBDatabase read FConnection write SetIBXConnection;
    property Transaction : TIBTransaction read FTransaction write SetFTransaction;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U;

{ TIBXUserControl }


procedure TIBXUserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TIBQuery.Create(self);
  TIBQuery(UserPermis.DSCmd).Database := FConnection;
  TIBQuery(UserPermis.DSCmd).Transaction := FTransaction;

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TIBXUserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TIBQuery.Create(self);

  TIBQuery(UserPermis.DSCmd).Database := FConnection;
  TIBQuery(UserPermis.DSCmd).Transaction := FTransaction;


  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TIBXUserControl.CriaCadUserForm;
begin
  inherited;
  TCadUser(FormCadastroUsuarios).DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
  TCadUser(FormCadastroUsuarios).DSCadUser.Open;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

  TCadUser(FormCadastroUsuarios).DScmd := TIBQuery.Create(self);

  TIBQuery(TCadUser(FormCadastroUsuarios).DSCMD).Database := FConnection;
  TIBQuery(TCadUser(FormCadastroUsuarios).DSCMD).Transaction := FTransaction;


  TCadUser(FormCadastroUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
  TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
end;

procedure TIBXUserControl.CriaProfileUserForm;
begin
  inherited;
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
  TCadPerfil(FormPerfilUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

  TCadPerfil(FormPerfilUsuarios).DSCmd := TIBQuery.Create(self);

  TIBQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).Database := FConnection;
  TIBQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).Transaction := FTransaction;


end;


procedure TIBXUserControl.SetIBXConnection(Value: TIBDatabase);
begin
  if FConnection <> Value then FConnection := Value;
  if FConnection <> nil then FConnection.FreeNotification(Self);
end;

procedure Register;
begin
  RegisterComponents('User Control', [TIBXUserControl]);
end;


procedure TIBXUserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FConnection) then FConnection := nil;
  if (Operation = opRemove) and (AComponent = FTransaction) then FTransaction := nil;
  inherited Notification(AComponent, Operation);
end;

procedure TIBXUserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).DSLog := TIBQuery.Create(nil);

  TIBQuery(tViewLog(FormLogControl).DSLog).Database := FConnection;
  TIBQuery(tViewLog(FormLogControl).DSLog).Transaction := FTransaction;

  TViewLog(FormLogControl).DSCmd :=TIBQuery.Create(nil);

  TIBQuery(tViewLog(FormLogControl).DSCmd).Database := FConnection;
  TIBQuery(tViewLog(FormLogControl).DSCmd).Transaction := FTransaction;

  FormLogControl.ShowModal;
  FreeandNil(FormLogControl);
end;


procedure TIBXUserControl.UCExecSQL(FSQL: String);
begin
  with TIBQuery.Create(nil) do
  begin
    Database := FConnection;
    Transaction := FTransaction;
    if not Transaction.Active then Transaction.Active := True;
    SQL.Text := FSQL;
    ExecSQL;
    FTransaction.Commit;
    Free;
  end;
end;


function TIBXUserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  Result := TIBQuery.Create(nil);
  with Result as TIBQuery do
  begin
    Database := FConnection;
    Transaction := FTransaction;
    SQL.text := FSQL;
    Open;
  end;
end;

procedure TIBXUserControl.SetFTransaction(const Value: TIBTransaction);
begin
  FTransaction := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TIBXUserControl.UCFindDataConnection: Boolean;
begin
  Result := Assigned(FConnection);
end;

function TIBXUserControl.UCFindTable(const TableName: String): Boolean;
var
  TempList : TStringList;
begin
  try
    TempList := TStringList.Create;
    FConnection.GetTableNames(TempList,False);
    TempList.Text := UpperCase(TempList.Text);
    Result := TempList.IndexOf(UpperCase(TableName)) >0;
  finally
    FreeAndNil(TempList);
  end;
end;

end.
